import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["children", "combine", "proviso"];
import PropTypes from 'prop-types';
import { combineClassNames, combineHandler, combineHandlers, combineProps, combineStyles, inject } from './settings.js';

var PrimitiveInjector = function PrimitiveInjector(_ref) {
  var children = _ref.children,
      _ref$combine = _ref.combine,
      combine = _ref$combine === void 0 ? combineProps : _ref$combine,
      _ref$proviso = _ref.proviso,
      proviso = _ref$proviso === void 0 ? function () {
    return true;
  } : _ref$proviso,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  return inject(children, [{
    combine: combine,
    proviso: proviso,
    props: props
  }]);
};

PrimitiveInjector.displayName = 'PrimitiveInjector';
PrimitiveInjector.propTypes = {
  /** inner virtual-dom elements **/
  children: PropTypes.node,

  /** function used to combine each children props with the injected given **/
  combine: PropTypes.func,

  /** function used to filter the desired injected children elements **/
  proviso: PropTypes.func
};
export default PrimitiveInjector;
export { inject, combineHandler, combineHandlers, combineStyles, combineClassNames, combineProps };